/* -*-c++-*- Producer - Copyright (C) 2001-2006  Don Burns
 *
 * This library is open source and may be redistributed and/or modified under
 * the terms of the OpenSceneGraph Public License (OSGPL) version 0.0 or
 * (at your option) any later version.  The full license is in LICENSE file
 * included with this distribution, and on the openscenegraph.org website.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * OpenSceneGraph Public License for more details.
 */
#ifndef FLKT_RENDER_SURFACE_DEF
#define FLKT_RENDER_SURFACE_DEF 1

#include <Producer/RenderSurface>
#include <FL/Fl_Gl_Window.H>

class FLTKRenderSurface: public Producer::RenderSurface, public Fl_Gl_Window
{
    public:

        FLTKRenderSurface( int X, int Y, int W, int H, const char *L="" ):
            Fl_Gl_Window(X, Y, W, H, L)
        {
        }

        virtual bool realize( Producer::VisualChooser *vc=NULL, Producer::GLContext sharedGLContext=0 ) 
        {
            if( _realized ) return _realized;
            _realized = true;
            return _realized;
        }

        void getWindowRectangle( int &_x, int &_y, unsigned int &_width, unsigned int &_height ) const
        {
            _x = x();
            _y = y();
            _width = w();
            _height = h();
        }

        virtual bool makeCurrent( bool ) 
        {
            make_current();
            return true;
        }

        virtual void swapBuffers()
        {
            swap_buffers();
        }

        virtual void draw()
        {
            if( _drawCallback != NULL )
                (*_drawCallback)(this, _drawCallbackData );
        }

        virtual void setDrawCallback( Fl_Callback *callback, void *data )
        {
            _drawCallback = callback;
            _drawCallbackData = data;
        }

    private:
            Fl_Callback *_drawCallback;
            void *_drawCallbackData;
};

#endif

