#ifndef OpenGLSceneHandler_def
#define OpenGLSceneHandler_def 1

#include <Producer/Camera>

extern void glutSolidTeapot(GLdouble);

class OpenGLSceneHandler: public Producer::Camera::SceneHandler
{
    public:
        OpenGLSceneHandler();

        virtual void draw( Producer::Camera &camera) ;
        virtual bool getSceneBounds( Producer::Vec3 &center, double &radius );
        void toggleLighting();
        void toggleBackfaceCulling();
        void toggleWireframe();
        void toggleTexturing();

    private:
        bool _inited;
        bool _lighting;
        bool _texturing;
        bool _backface;
        unsigned int _polymode;

        void _init();

        void _scribeMode();

};

#endif
