/* -*-c++-*- Producer - Copyright (C) 2001-2006  Don Burns
 *
 * This library is open source and may be redistributed and/or modified under
 * the terms of the OpenSceneGraph Public License (OSGPL) version 0.0 or
 * (at your option) any later version.  The full license is in LICENSE file
 * included with this distribution, and on the openscenegraph.org website.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * OpenSceneGraph Public License for more details.
 */
#ifndef QPRODUCER_DEF
#define QPRODUCER_DEF 1

#include <qgl.h>

#include <Producer/Camera>
#include <Producer/Trackball>
#include <osgDB/ReadFile>

#include <ProducerOSG/OsgSceneHandler.h>

class QProducer : public QGLWidget, public Producer::RenderSurface
{
    public:
        QProducer( QWidget *parent=0, const char *name=0 );

        virtual bool realize( Producer::VisualChooser * =NULL, Producer::GLContext =0 ) ;
        virtual bool makeCurrent( bool ) ;
        void setTimerInterval( int i ) { _timer_interval = i; }
        int getTimerInterval() { return _timer_interval; }

    protected:
        void initializeGL();
        void resizeGL( int, int );
        void paintGL();
        void timerEvent( QTimerEvent * );

        virtual void keyPressEvent( QKeyEvent* event );
        virtual void keyReleaseEvent( QKeyEvent* event );
        virtual void mousePressEvent( QMouseEvent* event );
        virtual void mouseReleaseEvent( QMouseEvent* event );
        virtual void mouseMoveEvent( QMouseEvent* event );

    private:

        Producer::ref_ptr<Producer::Camera> _camera;
        Producer::ref_ptr<Producer::Trackball> _trackball;

        int _timer_interval;
        int _mx, _my;
        unsigned int _mbutton;

        void _normalizeMouseXY( int x, int, float &nx, float &ny );
};

#endif
