/* -*-c++-*- Producer - Copyright (C) 2001-2006  Don Burns
 *
 * This library is open source and may be redistributed and/or modified under
 * the terms of the OpenSceneGraph Public License (OSGPL) version 0.0 or
 * (at your option) any later version.  The full license is in LICENSE file
 * included with this distribution, and on the openscenegraph.org website.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * OpenSceneGraph Public License for more details.
 */
#include <qapplication.h>
#include "QProducer.h"

int main( int argc, char **argv )
{
    int timer_interval = 10;			// timer interval (millisec)
    QApplication::setColorSpec( QApplication::CustomColor );
    QApplication a( argc, argv );

    if ( !QGLFormat::hasOpenGL() ) 
    {
	    qWarning( "This system has no OpenGL support. Exiting." );
	    return -1;
    }

    if ( argc >= 2 ) 
    {
	    bool ok = TRUE;
	    timer_interval = QString::fromLatin1( argv[1] ).toInt( &ok );
	    if ( !ok )
	        timer_interval = 10;
    }

    QProducer qProducer;
    qProducer.setTimerInterval( timer_interval );
    qProducer.setFixedSize( 640, 480 );
    a.setMainWidget( &qProducer );
    qProducer.show();
    return a.exec();
}
